package dev.fyloz.trial.colorrecipesexplorer.core.model;

import lombok.*;
import org.hibernate.validator.constraints.Length;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import java.io.Serializable;

@Entity
@Table(name = "companies")
@Data
@EqualsAndHashCode(callSuper = false)
@RequiredArgsConstructor
@NoArgsConstructor
public class Company extends BeanModel implements Serializable {

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE)
    private int companyID;

    @NonNull
    @NotNull
    @Length(min = 2, max = 50)
    @Column(unique = true)
    private String companyName;

    @Override
    public Integer getID() {
        return companyID;
    }
}
