package dev.fyloz.trial.colorrecipesexplorer.core.model;

import lombok.*;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import java.util.List;

@Entity
@Table(name = "mixes")
@Data
@EqualsAndHashCode(callSuper = false)
@RequiredArgsConstructor
@NoArgsConstructor
public class Mix extends BeanModel implements Serializable {

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE)
    @Basic
    private Integer mixID = 0;

    @NonNull
    @ToString.Exclude
    @NotNull
    @ManyToOne
    private Recipe recipe;

    @NonNull
    @NotNull
    @ManyToOne
    private MixType mixType;

    @OneToMany(mappedBy = "mix", cascade = CascadeType.ALL)
    private List<MixQuantity> mixQuantities;

    // Casier
    private String location;

    @Override
    public Integer getID() {
        return mixID;
    }

}
