package dev.fyloz.trial.colorrecipesexplorer.core.model;

import lombok.*;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import java.io.Serializable;

@Entity
@Table(name = "mixTypes")
@Data
@EqualsAndHashCode(callSuper = false)
@RequiredArgsConstructor
@NoArgsConstructor
public class MixType extends BeanModel implements Serializable {

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE)
    private int typeID;

    @NonNull
    @NotNull
    private String typeName;

    @NonNull
    @NotNull
    @OneToOne(cascade = CascadeType.ALL)
    @JoinColumn(name = "materialid")
    private Material material;

    @Override
    public Integer getID() {
        return typeID;
    }
}
